;
;  This function will read a data file created by df.pro using the
;	dataTemplate.dat format and return an array of structures
;	containing the measurements.  Please see the file
;	data__define.pro for the format of the data structure.
;
FUNCTION df_readfile

;         RESTORE,'/home/tdarnell/idl/image_tools/dataTemplate.dat'
;         RESTORE,'/home/tdarnell/idl/image_tools/dataTemplate2.dat'
         RESTORE,'dataTemplate2.dat'

;         file=DIALOG_PICKFILE(PATH='/bail/d/tdarnell/measurements',/READ, $
         file=DIALOG_PICKFILE(READ,FILTER='*.data')
         tempdata=READ_ASCII(file,TEMPLATE=dataTemplate)
         num_meas=SIZE(tempdata.dataset)
	 num_meas=num_meas[1]

	 meas_array=REPLICATE({data},num_meas)
         meas_array[*].dataset=tempdata.dataset
         meas_array[*].feature=tempdata.feature
         meas_array[*].radius=tempdata.radius
         meas_array[*].theta=tempdata.theta
         meas_array[*].error=tempdata.error
         meas_array[*].x=tempdata.x
         meas_array[*].y=tempdata.y
         meas_array[*].xcen=tempdata.xcen
         meas_array[*].ycen=tempdata.ycen
         meas_array[*].doy=tempdata.doy
         meas_array[*].time_str=tempdata.time_str
         meas_array[*].date_str=tempdata.date_str
         meas_array[*].mins=tempdata.mins
	 num_days=meas_array[num_meas-1].doy-meas_array[0].doy

         FOR i=0,num_meas-1 DO BEGIN
         datanum=STRTRIM(STRING(i+1),1)
         datanum=datanum+' '
         tempmeas=meas_array
	 IF (i GT 0) THEN $
         IF (meas_array[i].mins LT 1440) THEN $
         IF (meas_array[i].doy GT meas_array[0].doy) THEN $
                meas_array[i].mins=(meas_array[i].mins+1440)*num_days

         datastr=STRING(datanum,tempmeas[i].dataset,tempmeas[i].feature,$
           tempmeas[i].doy, tempmeas[i].time_str,tempmeas[i].radius, $
           tempmeas[i].theta, tempmeas[i].mins, $
           FORMAT="(A3,A5,A8,I5,A12,F10.2,F10.2,F10.2)")
         ;WIDGET_CONTROL,data_box,SET_VALUE=datastr,/APPEND
	 print,datastr
         ENDFOR
	
	RETURN,meas_array
END
