;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Document name: mk_java_movie.pro
; Created by:    Randy Meisner, HAO/NCAR, Boulder, CO, December 18, 1998
;
; Last Modified: Fri Dec 18 15:38:15 1998 by meisner (Randy Meisner) on hoth
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
PRO mk_java_movie, fname, help=help
;+
;
; PROJECT:
;       SunRISE/PSPT
;
; NAME:
;       
;
; PURPOSE:
;       
;
; CALLING SEQUENCE:
;
;       
;
; INPUTS:
;       
;
; OPTIONAL INPUTS: 
;       None.
;
; OUTPUTS:
;       None.
;
; OPTIONAL OUTPUTS:
;       None.
;
; KEYWORD PARAMETERS: 
;       /help.  Will call doc_library and list header, and return
;
; CALLS:
;       None.
;
; COMMON BLOCKS:
;       None.
;
; RESTRICTIONS: 
;       None.
;
; SIDE EFFECTS:
;       None.
;
; CATEGORY:
;       
;
; PREVIOUS HISTORY:
;       Written December 18, 1998, by Randy Meisner, HAO/NCAR, Boulder, CO
;
; MODIFICATION HISTORY:
;       
;
; VERSION:
;       Version 1, December 18, 1998
;-
;
;ON_ERROR, 2

IF(N_ELEMENTS(help) GT 0) THEN BEGIN
  doc_library,'mk_java_movie'
  RETURN
ENDIF

IF(N_PARAMS() NE 1) THEN BEGIN
  PRINT, ''
  PRINT, 'Usage:  mk_java_movie, fname [,help=help]'
  PRINT, ''
  RETURN
ENDIF

SPAWN,'ls -1 *.gif',fnarr
nx = 512L
ny = 512L

d = !d.name
nf = n_elements(fnarr)
movie = bytarr(nf*nx, ny)

print, 'NF:  ', nf
help,movie

set_plot, 'z'
device, set_resolution = [nx, ny]
   lct, '/home/stanger/color/bwy.lut'      ; Load color table.

FOR i = 0L, nf-1 DO BEGIN
   
   f = fnarr(i)
   print, 'Processing image '+strn(i)+' :: '+f
   ;im = readfits(f, /sil)
   read_gif,f,im,r,g,b
   tvlct,r,g,b

   tv,im
   tmp = tvrd()
   movie(i*nx:i*nx+(nx-1), *) = tmp
   
ENDFOR

print, 'Saving movie image to '+fname
write_jpeg, fname, movie, quality = 20
set_plot, d

RETURN

END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; End of 'mk_java_movie.pro'.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
